<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="巡检名称" prop="inspectName">
        <el-input
          v-model="queryParams.inspectName"
          placeholder="请输入巡检名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="巡检人" prop="inspectorName">
        <el-input
          v-model="queryParams.inspectorName"
          placeholder="请输入巡检人"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <!--<el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
		  :loading="exportLoading"
          @click="handleExport"
        >导出</el-button>
      </el-col>-->
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="infoList">
      <el-table-column label="巡检名称" align="center" prop="inspectName" />
      <el-table-column label="巡检人" align="center" prop="inspectorName" />
      <el-table-column label="巡检时间" align="center" prop="createTime" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-document"
            @click="handleDetail(scope.row)"
          >巡检详情</el-button>
          <el-button
            v-if="scope.row.hasDanger == '1'"
            size="mini"
            type="text"
            @click="handleDanger(scope.row)"
          >隐患查看</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改隐患日常巡检记录对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="900px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="巡检名称" prop="inspectName">
          <el-input v-model="form.inspectName" placeholder="请输入巡检名称" />
        </el-form-item>
        <el-form-item label="巡检内容">
          <editor v-model="form.inpsectContent" :min-height="192"/>
        </el-form-item>
        <el-form-item label="巡检人" prop="inspector">
          <el-input v-model="form.inspector" placeholder="请输入巡检人" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 巡检详情 -->
    <el-dialog title="巡检详情" :visible.sync="inspectDetailOpen" width="900px" append-to-body append-to-body destroy-on-close>
      <InspectDetail ref="inspectDetail"/>
    </el-dialog>

    <!-- 隐患信息 -->
    <el-dialog title="隐患信息" :visible.sync="dangerDetailOpen" width="1000px" append-to-body destroy-on-close>
      <!-- 隐患信息 -->
      <DangerDetailInfo ref="dangerDetail"/>
    </el-dialog>

  </div>
</template>

<script>
import { listInfo, getInfo, delInfo, addInfo, updateInfo, exportInfo } from "@/api/dangerinspect/inspect";
import Editor from '@/components/Editor';
import InspectDetail from "./components/InspectDetail";
import DangerDetailInfo from "@/views/checktask/task/components/DangerDetailInfo";
import { listDanger } from "@/api/checktask/danger";
export default {
  name: "Info",
  components: {
    Editor,
    InspectDetail,
    DangerDetailInfo
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 隐患日常巡检记录表格数据
      infoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        inspectName: null,
        inpsectContent: null,
        inspector: null,
        inspectorName: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      },
      dangerDetailOpen: false,
      inspectDetailOpen: false
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询隐患日常巡检记录列表 */
    getList() {
      this.loading = true;
      listInfo(this.queryParams).then(response => {
        this.infoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        inspectName: null,
        inpsectContent: null,
        inspector: null,
        createTime: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加隐患日常巡检记录";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getInfo(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改隐患日常巡检记录";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateInfo(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addInfo(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除隐患日常巡检记录编号为"' + ids + '"的数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(function() {
          return delInfo(ids);
        }).then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm('是否确认导出所有隐患日常巡检记录数据项?', "警告", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.exportLoading = true;
          return exportInfo(queryParams);
        }).then(response => {
          this.download(response.msg);
          this.exportLoading = false;
        }).catch(() => {});
    },
    handleDetail(row){
      getInfo(row.id).then( res => {
        //this.form = response.data;
        this.inspectDetailOpen = true;
        this.$nextTick(() => {
          this.$refs.inspectDetail.inspectDetailInfo = res.data;
          this.$refs.inspectDetail.inspectDetailInfo.inspectContent = JSON.parse(res.data.inspectContent);
        })

      });
    },
    handleDanger(row) {
      listDanger({pageNum: 1,pageSize: 99999,inspectId:row.id,type:8}).then((response) => {
          if(response.code != 200 || response.rows == null || response.rows.length == 0){
          this.$message.error("未查到隐患信息！");
          return;
        }
        this.dangerDetailOpen = true;
        this.$nextTick(() => {
            this.$refs.dangerDetail.getList(response);
        });
      })
    },
  }
};
</script>
